#ifndef _GIV_POLY1_H_
#define _GIV_POLY1_H_
// ==========================================================================
// $Source: /local/cvs/Givaro/src/library/poly1/givpoly1.h,v $
// Copyright(c)'94-97 by Givaro Team
// see the copyright file.
// Authors: T. Gautier
// $Id: givpoly1.h,v 1.1.1.1 2003/02/06 22:32:15 giorgi Exp $
// ==========================================================================
// Description:

#include "giverror.h"
#include "givarray0.h"
#include "givcategory.h"
#include "giviterator.h"
#include "givops.h"


// ==========================================================================
// --
// -- Poly1Dom<Domain,StorageTag>:
// --
// ==========================================================================
template<class Domain, class StorageTag> class Poly1Dom;

template<class Domain> class Poly1Dom<Domain,Dense>;
template<class Domain> class Poly1Dom<Domain,Sparse>;

#include "givpoly1dense.h"
// #include "givvectorsparse.h"
// -- should be included in specialized class #include "givvectops.inl"
#include "givpoly1denseops.inl"
// #include "givvectsparseops.inl"

#endif
